using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace TestOp
{

    public partial class Form1 : Form
    {
        #region DLL Import
        //DLL Import for 1DSC
        [DllImport("y1d4x_aa.dll")]
        private static extern void Y1DPackG(ref int ErrorNumb, ref int ErrorMsgs,
            string RegCustomer, int RegPassword, int CostOptim, int IgnoreLast,
            int EffortLev, int ReduceLays, int PrefShort, int DiffStocks,
            int DiffPieces, int ReusLength, int GapItIt, int GapItEnd,
            int GapGripEnd, int OptimTime, int IterMult, int LayByMark,
            int RunMsgMode, int ReservInp2, ref int StockGrLth, ref int StockGrCst,
            ref short  StockGrQty, ref int PartGrLth, ref int PartGrMrkID, ref short PartGrQty,
            ref int Critsum, ref int Effsum, ref int StockSum, ref int PartSum,
            ref int LengthSum, ref int WasteSum, ref int CostSum, ref int LastStockNo,
            ref int LastParts, ref int LastLength, ref int LastWaste, ref int LastCost,
            ref int PatternSum, ref int LayoutSum, ref int LayoutCuts, ref int ReservOut1,
            ref int ReservOut2, ref short StockGrNo, ref short PartGrNo, ref short  PartStockNo,
            ref short StockLayNo, ref short StockPatNo, ref short StockParts, ref int StockWaste);
        [DllImport("y1d4x_aa.dll")]
        private static extern void Y1DPackB(ref int ErrorNumb, ref int ErrorMsgs,
            string RegCustomer, int RegPassword, int CostOptim, int IgnoreLast,
            int EffortLev, int ReduceLays, int PrefShort, int DiffStocks,
            int DiffPieces, int ReusLength, int GapItIt, int GapItEnd,
            int GapGripEnd, int OptimTime, int IterMult, int LayByMark,
            int RunMsgMode, int ReservInp2,
            ref int StockLength, ref int StockCost, ref int PartLength, ref int PartMarkID,
            ref int Critsum, ref int Effsum, ref int StockSum, ref int PartSum,
            ref int LengthSum, ref int WasteSum, ref int CostSum, ref int LastStockNo,
            ref int LastParts, ref int LastLength, ref int LastWaste, ref int LastCost,
            ref int PatternSum, ref int LayoutSum, ref int LayoutCuts, ref int ReservOut1,
            ref int ReservOut2,
            ref short  PartStockNo,
            ref short StockLayNo, ref short StockPatNo, ref short StockParts, ref int StockWaste);

        //BoxMax, CntMax..- array limits MUST be equal to BoxMax, CntMax.. in DLL

        //Activate below Const declarations in case of Demo DLL version !
        const int BoxMax = 100;
        const int CntMax = 100;
        const int BoxGrMax = 20;
        const int CntGrMax = 10;
        //Activate below Const declarations in case of Working DLL version !
        /*
        const int BoxMax = 5000;
        const int CntMax = 5000;
        const int BoxGrMax = 1000;
        const int CntGrMax = 100;        
        */
        const int StockCheck = 555;      //Any integer values just for DLL transfer checks
        const int PartCheck = 777;

        int CallMode;        //  0/1, 0 - Y1DPackG, group arrays, 1 - Y1DPackB, line arrays
        int StockLthGr1;    //  1-st stock group Length to modify in this demo

        //  ***  Current C# program working variables  ***

        int StockNmb;        // Actual Stock / Part item numbers
        int PartNmb;
        int StockGrNmb;      // Actual Stock / Part group numbers
        int PartGrNmb;

        int ErrorNumb;       // DLL return error code, 0 = OK
        int ErrorMsgs;       // DLL switch to display or not error messages - On/Off = 1/0

        string RegCustomer;   // DLL input login data
        int RegPassword;

        int CostOptim;      // DLL input Optim.Settings (similar to 1DSC)
        int IgnoreLast;
        int EffortLev;
        int ReduceLays;
        int PrefShort;
        int DiffStocks;
        int DiffPieces;
        int ReusLength;
        int GapItIt;
        int GapItEnd;
        int GapGripEnd;
        int OptimTime;
        int IterMult;
        int LayByMark;
        int RunMsgMode;
        int ReservInp2;

        int Critsum;          //DLL output solution totals
        int Effsum;
        int StockSum;
        int PartSum;
        int LengthSum;
        int WasteSum;
        int CostSum;
        int LastStockNo;
        int LastParts;
        int LastLength;
        int LastWaste;
        int LastCost;
        int PatternSum;
        int LayoutSum;
        int LayoutCuts;
        int ReservOut1;
        int ReservOut2;

        int[] StockGrLth = new int[CntGrMax + 1];    // DLL input arrays for Y1DPackG procedure
        int[] StockGrCst = new int[CntGrMax + 1];
        short[] StockGrQty = new short[CntGrMax + 1];
        int[] PartGrLth = new int[BoxGrMax + 1];
        int[] PartGrMrkID = new int[BoxGrMax + 1];
        short[] PartGrQty = new short[BoxGrMax + 1];

        int[] StockLength = new int[CntMax + 1];     // DLL input arrays for Y1DPackB procedure
        int[] StockCost = new int[CntMax + 1];
        int[] PartLength = new int[BoxMax + 1];
        int[] PartMarkID = new int[BoxMax + 1];

        short[] StockGrNo = new short[CntMax + 1];
        //StockGrNo[j] = initial group reference No for Stock[j]
        short[] PartGrNo = new short[BoxMax + 1];
        //PartGrNo[i] = initial group reference No for Part[i]
        // DLL output solution arrays  = new int[future results]
        short[] PartStockNo = new short[BoxMax + 1];
        //PartStockNo[i] = Stock No assigned to Part[i]
        short[] StockLayNo = new short[CntMax + 1];
        //StockLayNo[j] = Layout No assigned to Stock[j]
        short[] StockPatNo = new short[CntMax + 1];
        //StockPatNo[j] = Pattern No assigned to Stock[j]
        short[] StockParts = new short[CntMax + 1];
        //StockParts[j] = Total part number in Stock[j]
        int[] StockWaste = new int[CntMax + 1];
        //StockWaste[j] = Individual waste in Stock[j]
        #endregion

        private void InitVariables()
        {
            //=== Clear DLL arguments/arrays before call ===

            for (int i = 0; i < (CntMax + 1); i++)
            {
                StockGrNo[i] = 0;
                StockLayNo[i] = 0;
                StockPatNo[i] = 0;
                StockParts[i] = 0;
                StockWaste[i] = 0;
                StockLength[i] = 0;
                StockCost[i] = 0;
            }
            for (int i = 0; i < (BoxMax + 1); i++)
            {
                  PartGrNo[i] = 0;
                  PartStockNo[i] = 0;
                  PartLength[i] = 0;
                  PartMarkID[i] = 0;
            }
            for (int i = 0; i < (CntGrMax + 1); i++)
            {
                  StockGrLth[i] = 0;
                  StockGrCst[i] = 0;
                  StockGrQty[i] = 0;
            }
            for (int i = 0; i < (BoxGrMax + 1); i++)
            {
                  PartGrLth[i] = 0;
                  PartGrMrkID[i] = 0;
                  PartGrQty[i] = 0;
            }

            //=== Clear result variables before call ===
            ErrorNumb = 0;
            Critsum = 0;
            Effsum = 0;
            StockSum = 0;
            PartSum = 0;
            LengthSum = 0;
            WasteSum = 0;
            CostSum = 0;
            LastStockNo = 0;
            LastParts = 0;
            LastLength = 0;
            LastWaste = 0;
            LastCost = 0;
            PatternSum = 0;
            LayoutSum = 0;
            LayoutCuts = 0;
            ReservOut1 = 0;   //Reserved
            ReservOut2 = 0;   //Reserved

            ErrorMsgs = 1;    //DLL to display error messages On/Off = 1/0

            //=== Define optimizer settings (DLL input arguments) ===

            CostOptim = 0;    // 0/1 = false/true - stands for boolean
            IgnoreLast = 1;   // 0/1 = false/true - stands for boolean

            PrefShort = 0;    // 0..3 - factor, 0 = No, 3 = max
            ReduceLays = 0;   // 0..3 - factor, 0 = No, 3 = max
            EffortLev = 5;    // 0..5/8/10 - factor

            DiffStocks = 0;   // >= 0, all integers!
            DiffPieces = 0;   // >= 0
            ReusLength = 0;   // >= 0

            GapItIt = 0;      // >= 0, all integers!
            GapItEnd = 0;     // >= 0,
            GapGripEnd = 0;   // >= 0,

            IterMult = 20;    // 1..20
            OptimTime = 555;  // >= 5
            LayByMark = 0;    // 0/1 = false/true - stands for boolean
            RunMsgMode = 2;   // 0 - Off; 1 - On; 2 - On + Esc abort
            ReservInp2 = 0;   // Reserved

            //*** Define group array input data for DLL-procedure Y1DPackG ***

            //!!! THIS IS THE ONLY PLACE WHERE YOU CAN DEFINE/CORRECT TEST INPUT
            //!!! AND JUST BY GROUPPED INPUT ARRAYS: StockGr**[i] or PartGr**[i]

            StockGrNmb = 1;          //define total number of identical stock groups
            StockGrLth[1] = 350;     //define example stock lengths - all integers!
            StockGrCst[1] = 0;       //define example stock costs - all integers!
            StockGrQty[1] = 10;      //define example stock quantities [1-st group]

            PartGrNmb = 3;           //define total number of identical part groups
            PartGrLth[1] = 162;      //define example part lengths - all integers!
            PartGrMrkID[1] = 0;      //define example mark IDs - all integers!
            PartGrQty[1] = 5;        //define example part quantities [1-st part group]

            PartGrLth[2] = 94;       // - the same for 2-d part group
            PartGrMrkID[2] = 0;
            PartGrQty[2] = 5;

            PartGrLth[3] = 48;       // - the same for 3-d part group
            PartGrMrkID[3] = 0;
            PartGrQty[3] = 10;
            //!!! NO ANY FURTHER CORRECTIONS for the TEST INPUT ALLOWED ---------

            //*** Derive line array input data for DLL-procedure Y1DPackB ***

            StockNmb = 1;
            for(int j = 1; j < (StockGrNmb + 1); j++)
            {
                for(int p = 1; p < (StockGrQty[j] + 1); p++)
                {
                  
                  StockLength[StockNmb] = StockGrLth[j]; //define example stock lengths - all integers!
                  StockCost[StockNmb] = StockGrCst[j];   //define example stock costs - all integers!
                  StockNmb = StockNmb + 1;               //count total number of stocks to use
                }
            }
            StockNmb--;


           
            PartNmb = 1;
            for(int j = 1; j < (PartGrNmb+1); j++)
            {
                for(int i = 1; i < (PartGrQty[j]+1); i++)
                {                
                      PartLength[PartNmb] = PartGrLth[j];    //define example part lengths - all integers!
                      PartMarkID[PartNmb] = PartGrMrkID[j];  //define example mark IDs - all integers!
                      PartNmb = PartNmb + 1; //count total number of parts to cut
                }
            }
            PartNmb--;
            

            StockGrLth[0] = StockGrNmb;      //place array lengths in elem[0]!  [for Y1DPackG input]
            StockGrCst[0] = StockGrNmb;
            StockGrQty[0] = (short)StockGrNmb;
            PartGrLth[0] = PartGrNmb;
            PartGrMrkID[0] = PartGrNmb;
            PartGrQty[0] = (short)PartGrNmb;

            StockGrLth[StockGrNmb + 1] = StockCheck;     //place array check codes in elem[n+1]!
            StockGrCst[StockGrNmb + 1] = StockCheck;
            StockGrQty[StockGrNmb + 1] = StockCheck;
            PartGrLth[PartGrNmb + 1] = PartCheck;
            PartGrMrkID[PartGrNmb + 1] = PartCheck;
            PartGrQty[PartGrNmb + 1] = PartCheck;

            StockLength[0] = StockNmb;       //place array lengths in elem[0]!  [for Y1DPackB input]
            StockCost[0] = StockNmb;
            PartLength[0] = PartNmb;
            PartMarkID[0] = PartNmb;

            StockLength[StockNmb + 1] = StockCheck;      //place array check codes in elem[n+1]!
            StockCost[StockNmb + 1] = StockCheck;
            PartLength[PartNmb + 1] = PartCheck;
            PartMarkID[PartNmb + 1] = PartCheck;
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void btnStockLenUp_Click(object sender, EventArgs e)
        {
            StockLthGr1 = StockLthGr1 - 10;            //to modify Stock Length value - Down
            if (StockLthGr1 < 200)
            {
                StockLthGr1 = 200;
            }
            LengthText.Text = StockLthGr1.ToString();
        }

        private void btnStockLenDown_Click(object sender, EventArgs e)
        {
            StockLthGr1 = StockLthGr1 + 10;            //to modify Stock Length value - Up
            if (StockLthGr1 > 500)
            {
                StockLthGr1 = 500;
            }
            LengthText.Text = StockLthGr1.ToString();
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void FillTexts()
        {
            NumberText.Text = PartNmb.ToString();
            StocksText.Text = StockNmb.ToString();
            LeftText.Text = Convert.ToString(PartNmb - PartSum);
            UsedText.Text = StockSum.ToString();
            WastText.Text = WasteSum.ToString();
            UtilText.Text = Convert.ToString(Convert.ToDouble(Effsum) / 1000);
        }

        private void FillLists(bool dat)
        {
            //int i;
            int k;
            int k0;
            string spacer;
            string lastmk;
            

            // List1
            List1.Items.Clear();
            List1.Items.Add("i    PartLength[i]");
            List1.Items.Add("");
            for (int i = 1; i < (PartNmb+1); i++)
            {
                spacer = "     ";
                if (i < 10) spacer = spacer + "  ";
                List1.Items.Add(i + spacer + PartLength[i].ToString());
            }

            //List2
            List2.Items.Clear();
            List2.Items.Add("i    PartGrNo[i]");
            List2.Items.Add("");
            if (dat)
            {
                for (int i = 1; i < (PartNmb+1); i++)
                {
                    spacer = "     ";
                    if (i < 10) spacer = spacer + "  ";
                    List2.Items.Add(i + spacer + PartGrNo[i].ToString());
                }
            }

            //List3
            List3.Items.Clear();
            List3.Items.Add("i   PartStockNo[i]");
            List3.Items.Add("       = k"); 
            if (dat)
            {
                for (int i = 1; i < (PartNmb+1); i++)
                {
                    k = PartStockNo[i];
                    if (k == LastStockNo && k != 0)
                    {
                        lastmk = " - Last stock";
                    } 
                    else
                    {
                        lastmk = "";
                    }
                    spacer = "     ";
                    if (i < 10) spacer = spacer + "  ";
                    List3.Items.Add(i + spacer + PartStockNo[i].ToString() + lastmk);

                }
            }
            //List4
            List4.Items.Clear();
            List4.Items.Add("k   Parts in Stock[k]");
            List4.Items.Add(""); 
            if (dat) 
            {
                for(int i = 1; i < (PartNmb+1); i++)
                {
                    k = PartStockNo[i];
                    if (k == LastStockNo && k != 0) lastmk = " - Last stock"; else lastmk = "";
                    spacer = "     ";
                    if (k < 10) spacer = spacer + "  ";
                    if (k == 0) k0 = 0; else k0 = 1;
                    List4.Items.Add(k.ToString() + spacer + Convert.ToString(k0 * StockParts[k]) + lastmk);
                }
            }

            //List5
            List5.Items.Clear();
            List5.Items.Add("k    Length - Waste");
            List5.Items.Add(""); 
            if (dat) 
            {
                for (int i = 1; i < PartNmb; i++)
                {
                    k = PartStockNo[i];
                    spacer = "     ";
                    if (k < 10) spacer = spacer + "  ";
                    if (k == 0) k0 = 0; else k0 = 1;
                    List5.Items.Add(k.ToString() + spacer + Convert.ToString(k0 * StockLength[k]) + "   - " + Convert.ToString(k0 * StockWaste[k]));
                }
            }
        }
        public void RegLogin()
        {
            RegCustomer = "Astrokettle Algorithms";    //Demo registration login/password arguments
            RegPassword = 5555555;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            InitVariables();
                StockLthGr1 = StockLength[1];            //Init Stock Length UpDown control
                LengthText.Text = StockLthGr1.ToString();
            FillTexts();
            FillLists(false);
        }

        private void btnCallDll_Click(object sender, EventArgs e)
        {
            CallDll();
        }

        private void CallDll()
        {
            if (Option1.Checked == true) CallMode = 0; else CallMode = 1;
            InitVariables();

                                    //Stock Length UpDown control:
            StockGrLth[1] = StockLthGr1;       //correct example stock lengths from user input
            for(int i = 1; i < StockGrQty[1]; i++)        //only for the first stock group
            {
                StockLength[i] = StockGrLth[1];
            }
            FillTexts();            // Fill form controls with the data
            FillLists(false);       // Fill form listboxes with the data

            RegLogin();             // Fill Registration login/password arguments (see below)

  
            WaitLabel.Visible = true;

            if (CallMode == 0)     // Y1DPackG call mode
            {                     // Keep call arguments order strictly fixed!
                try
                {
                    Y1DPackG(ref ErrorNumb, ref ErrorMsgs, RegCustomer, RegPassword, CostOptim, IgnoreLast,
                        EffortLev, ReduceLays, PrefShort, DiffStocks, DiffPieces, ReusLength,
                        GapItIt, GapItEnd, GapGripEnd, OptimTime, IterMult, LayByMark, RunMsgMode, ReservInp2,
                        ref StockGrLth[0], ref StockGrCst[0], ref StockGrQty[0], ref PartGrLth[0], ref PartGrMrkID[0], ref PartGrQty[0],
                        ref Critsum, ref Effsum, ref StockSum,
                        ref PartSum, ref LengthSum, ref WasteSum, 
                        ref CostSum, ref LastStockNo, ref LastParts,
                        ref LastLength, ref LastWaste, ref LastCost,
                        ref PatternSum, ref LayoutSum, ref LayoutCuts, ref ReservOut1,
                        ref ReservOut2, ref StockGrNo[0], ref PartGrNo[0], 
                        ref PartStockNo[0], ref StockLayNo[0], ref StockPatNo[0],
                        ref StockParts[0], ref StockWaste[0]);    //all arrays with "[0]"!
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString(), "ERROR!");
                }
            }
            else
            {
                try
                {
                    Y1DPackB(ref ErrorNumb, ref ErrorMsgs, RegCustomer, RegPassword,
                        CostOptim, IgnoreLast, EffortLev, ReduceLays, PrefShort, DiffStocks, DiffPieces, ReusLength,
                        GapItIt, GapItEnd, GapGripEnd, OptimTime, IterMult, LayByMark, RunMsgMode, ReservInp2,
                        ref StockLength[0], ref StockCost[0], ref PartLength[0], ref PartMarkID[0], ref Critsum, ref Effsum,
                        ref StockSum, ref PartSum, ref LengthSum, ref WasteSum, ref CostSum, ref LastStockNo, ref LastParts,
                        ref LastLength, ref LastWaste, ref LastCost, ref PatternSum, ref LayoutSum, ref LayoutCuts, ref ReservOut1, ref ReservOut2,
                        ref PartStockNo[0], ref StockLayNo[0], ref StockPatNo[0], ref StockParts[0], ref StockWaste[0]);    //all arrays with "[0]"!
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString(), "ERROR!");
                }
            }



            WaitLabel.Visible = false;
                                //=== Either CallMode DLL checks ===
            if (ErrorNumb != 0)
            {
                MessageBox.Show("DLL Error: " + ErrorNumb.ToString(), "DLL ERROR");
            }
            else 
            {
                if (PartStockNo[PartNmb + 1] != (StockCheck + PartCheck)) MessageBox.Show("Error DLL transfer check /PartStockNo", "DLL ERROR");  //To check for DLL transfer errors
                if (StockLayNo[StockNmb + 1] != (StockCheck + PartCheck)) MessageBox.Show("Error DLL transfer check /StockLayNo", "DLL ERROR");
                if (StockPatNo[StockNmb + 1] != (StockCheck + PartCheck)) MessageBox.Show("Error DLL transfer check /StockPatNo", "DLL ERROR");
                if (StockParts[StockNmb + 1] != (StockCheck + PartCheck)) MessageBox.Show("Error DLL transfer check /StockParts", "DLL ERROR");
                if (StockWaste[StockNmb + 1] != (StockCheck + PartCheck)) MessageBox.Show("Error DLL transfer check StockWaste", "DLL ERROR");
                if (CallMode == 0)      //Checks for CallMode=0 case only
                {
                    if (StockGrNo[StockNmb + 1] != (StockCheck + PartCheck)) MessageBox.Show("Error DLL transfer check StockGrNo", "DLL ERROR");
                    if (PartGrNo[PartNmb + 1] != (StockCheck + PartCheck)) MessageBox.Show("Error DLL transfer check PartGrNo", "DLL ERROR");
                }

                FillTexts();
                FillLists(true);
            }
        }

    }
}